<?
  /**
   * Title: JOWAMP_About.php
   * Description: This file contains the code used to create the web page JOWAMP_About, where an user can read
	 * some information about the J-OWAMP implementation.
   * Copyright: Copyright (c) 2005
   * Company: University of Aveiro / Institute of Telecommunications - Aveiro pole 
   * @author Helder Veiga 
   * @version 1.2
	 * @Last updated: 9-12-2005
 	 *
 	 * Copyright (C) 2005  Helder Veiga 
 	 *
 	 * This program is free software; you can redistribute it and/or
 	 * modify it under the terms of the GNU General Public License
 	 * as published by the Free Software Foundation; either version 2
 	 * of the License, or (at your option) any later version.
 	 *
 	 * This program is distributed in the hope that it will be useful,
 	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 	 * GNU General Public License for more details.  A HTML version of 
 	 * the GNU General Public License can be seen at
 	 * http://www.gnu.org/licenses/gpl.html.
 	 *
	 */
	 
if(!isset($logged_in)){	// Used in EMP site
	echo "<LINK href='../JOWAMP_files/emp.css' rel=stylesheet>";
  // If this is an EMP web site, the links are located in:
  $detailsLink = "./JOWAMP_Details.php"; 
	$downloadsLink = "./JOWAMP_Downloads.php";
	$mysqlConnectorLink = "./auxiliaryFiles/mysql-connector-java-3.1.6-bin.jar";
}else{  // If this is a JOWAMP web site, the links are located in: 
  $detailsLink = "JOWAMP_files/JOWAMP_ShowPage.php?link=JOWAMP_Details.php"; 
	$downloadsLink = "JOWAMP_files/JOWAMP_ShowPage.php?link=JOWAMP_Downloads.php";
	$mysqlConnectorLink = "JOWAMP_files/auxiliaryFiles/mysql-connector-java-3.1.6-bin.jar";
}	
?>	
	<SPAN class=utitre2>
		<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;J-OWAMP - Measurement Platform</STRONG></FONT></P>
	</SPAN>	
  <div style='margin-left:20.3pt;margin-right:20.3pt;'>
	The traffic management of IP networks faces increasing challenges, due to the occurrence of sudden and deep traffic variations in the network, which can be mainly attributed to the large diversity of supported applications and services, to the drastic differences in user behaviors, and to the complexity of traffic generation and control mechanisms. In this context, active traffic measurements are particularly important since they allow characterizing essential aspects of network operation, namely the quality of service measured in terms of packet delays and losses.
  <br>
	<br>
  J-OWAMP is a Java implementation of the One-Way Active Measurement Protocol (OWAMP). OWAMP is a recent proposal of the <a
  href="http://e2epi.internet2.edu/owamp/">Internet2</a> group and is currently being standardized by <a href="http://www.ietf.org/">IETF</a> under the scope of the IPPM group. OWAMP is an architecture to perform active measurements of one-way delays and losses between hosts.
  <br>
	<br>
	The version of J-OWAMP used in this tool (version 1.2) implements the May 2004 draft proposal of OWAMP (<a href="http://www.internet2.edu/~shalunov/ippm/draft-ietf-ippm-owdp-08.txt">http://www.internet2.edu/~shalunov/ippm/draft-ietf-ippm-owdp-08.txt</a>). To learn more details on J-OWAMP click <a href=<?php echo $detailsLink; ?>>here</a>. To download the code and the users manual click <a href=<?php echo $downloadsLink;?>>here</a>. 
  <br>
	<br>
	This tool is an J-OWAMP web interface which provides a friendly user interface for J-OWAMP implementation.  
	<br>
	<br>
	With J-OWAMP it is possible to accomplish two kinds of test sessions: single test sessions and confidence interval test sessions. The single test session corresponds to the configuration of one single test between two machines. The user can define the number of packets, the packet interarrivals, the packet length and the start time of the session. The results obtained with this type of session are the estimation performance metrics such as mean delay, losses, duplication and throughput. The confidence interval test session allows splitting the complete session period in a number of smaller test intervals and to perform a set of tests in each interval to enable the construction of 90% confidence intervals. For example, if the session period is set at 24 hours, the user can define 24 intervals (of one hour duration), and define also that in each interval a total of 10 tests should be performed in order to calculate the 90% confidence interval. In this case, the interval between the start of consecutive session can also be defined (say 2 minutes). 
  <br>
	<br>
  If you need some help please contact <a href="mailto:hveiga@av.it.pt">Hlder Veiga</a>.
  </div>
	<br>
	<br>
	<br>
	<div style='margin-left:12pt;margin-right:12pt;'>
	<![if !pub]>
  <hr size=1 noshade style="color:#000000">
  <![endif]>
	</div>
  <SPAN class=utitre2>
		<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;REQUIREMENTS</STRONG></FONT></P>
	</SPAN>
	<div style='margin-left:20.3pt;margin-right:20.3pt;'>	
  OWAMP requires a synchronized clock for measurements to be meaningful. But, more importantly, the clock needs to be stable. If the system clock is stepped during an OWAMP session, the results can be misleading. OWAMP requires that GPS or NTP are used to synchronize the system clock. More details on configuring NTP can be found at <a
  href="http://www.eecis.udel.edu/~mills/ntp/html/notes.html">http://www.eecis.udel.edu/~mills/ntp/html/notes.html</a>.
	<br>
	<br>
	J-OWAMP requires the J2SE Java Runtime Environment (JRE) (<a
  href="http://java.sun.com/j2se/1.5.0/download.jsp">http://java.sun.com/j2se/1.5.0/download.jsp</a>) that allows end-users to run Java applications. The J2SE Java Runtime Environment (JRE) 5.0 is needed for IPv6 support on Microsoft Windows. With the J2SDK/JRE 1.4 release, there is IPv6 support on Linux. 
  <br>
	<br>
	You must also save a MySQL Connector/J file (<a
  href="http://dev.mysql.com/downloads/">http://dev.mysql.com/downloads/</a>) in the "&lt;jre_diretory&gt;\lib\ext" directory to allows interaction between J-OWAMP and a MySQL database. MySQL Connector/J is used for connecting to MySQL from Java. While testing this tool, we used the <a href="JOWAMP_files/auxiliaryFiles/mysql-connector-java-3.1.6-bin.jar">MySQL Connector/J 3.1</a> version. 
	<br>
	<br>
	To visualize the graphs, in the results section, the user must install a <a href="http://www.macromedia.com/go/getflashplayer">Flash Player</a>. 
	</div>
	<br>
	<br>
	<br>
	<div style='margin-left:12pt;margin-right:12pt;'>
  <![if !pub]>
  <hr size=1 noshade style="color:#000000">
  <![endif]>
	</div>
	<SPAN class=utitre2>
		<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;SUPPORTED SYSTEMS</STRONG></FONT></P>
	</SPAN>	
	<div style='margin-left:20.3pt;margin-right:20.3pt;'>
  J-OWAMP has been tested most extensively on Windows and Linux.
	</div>
	<br>
	<br>
	<br>
	<div style='margin-left:12pt;margin-right:12pt;'>
	<![if !pub]>
  <hr size=1 noshade style="color:#000000">
  <![endif]>
	</div>
  <SPAN class=utitre2>
		<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;RECOMMENDED HARDWARE</STRONG></FONT></P>
	</SPAN>
	<div style='margin-left:20.3pt;margin-right:20.3pt;'>
	J-OWAMP does not have any strict hardware requirements. More tasking packet send schedules will of course require more capable hardware but low bandwidth schedules with small packets can be done on fairly modest hardware.
  </div>
	<br>
	<br>
	<br>
	<div style='margin-left:12pt;margin-right:12pt;'>
	<![if !pub]>
  <hr size=1 noshade style="color:#000000">
  <![endif]>
	</div>
  <SPAN class=utitre2>
		<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;ADDITIONAL REMARKS</STRONG></FONT></P>
	</SPAN>
	<div style='margin-left:20.3pt;margin-right:20.3pt;'>
	The time synchronization, accuracy and resolution are some of the most important requirements of OWAMP. Better accuracy and resolution can be obtained by using performance counters in conjunction with the system time, in order to calculate accurate and smaller time increments. To do so, a time reference should be defined. In any instant the current time can be determined as follows: currentTime = timeReference + (currentCounterValue - referenceCounterValue)/counterFrequency. The time reference can be defined by using the system time, in which case the system should be synchronized, or directly from a NTP server. J-OWAMP allows these two approaches. For the second approach, J-OWAMP includes a NTP client which can be used to get the time reference directly from a NTP server, without the requirement of a synchronized clock on the machine hosting J-OWAMP. This approach can lead to even better results than the first one. On both approaches, time reference should be frequently synchronized. Therefore, an update interval should be defined. 
	<br>
	<br>
  When using J-OWAMP on Windows platforms with the system time approach, we should be aware that the timestamps obtained from Windows are limited to a maximum resolution of 10 to 15 milliseconds, depending on the underlying hardware. As previously said, a better resolution can be obtained by using performance counters in conjunction with the system time (in order to calculate smaller time increments). But, even in this solution it is necessary to have an accuratetime reference obtained from the system time, which does not happen on Windows. Thus, results can be misleading evenwhen the machines used in the measurement setup are synchronized. Therefore, we advise the use of J-OWAMP in Linux platforms whenever a resolution better than a few milliseconds is required.
  </div>
	<br>
  <br>
	<br>
	<br>
  
	