<?php
  /**
   * Title: JOWAMP_AuxiliaryFunctions.php
   * Description: This file contains the code used to define the auxiliary functions used in this project.
   * Copyright: Copyright (c) 2005
   * Company: University of Aveiro / Institute of Telecommunications - Aveiro pole 
   * @author Helder Veiga 
   * @version 1.2
	 * @Last updated: 9-12-2005
 	 *
 	 * Copyright (C) 2005  Helder Veiga 
 	 *
 	 * This program is free software; you can redistribute it and/or
 	 * modify it under the terms of the GNU General Public License
 	 * as published by the Free Software Foundation; either version 2
 	 * of the License, or (at your option) any later version.
 	 *
 	 * This program is distributed in the hope that it will be useful,
 	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 	 * GNU General Public License for more details.  A HTML version of 
 	 * the GNU General Public License can be seen at
 	 * http://www.gnu.org/licenses/gpl.html.
 	 *
	 */
	 	
	// Set the maximum execution time to 5 minutes. Some session has a lot results, so a bigger time of execution is bether.
	// Also, a timeout of 30 seconds is used on socket connection, so just 30 seconds (default value) of maximum execution 
	// time is not enough. 
	set_time_limit(300);
	
/**
 * Function used to execute the command $exe with the arguments $args in background. It works
 * in Windows and Linux platforms.
 */
function execInBackground($exe, $args = "") {

  if (substr(php_uname(), 0, 7) == "Windows"){
		$WshShell = new COM("WScript.Shell"); 
    $oExec = $WshShell->Run($exe." ".$args, 7, false); 
  }else{
       
	 $exe = str_replace(" ", "%20", $exe);
   $args = str_replace(" ", "%20", $args);
      
   $fp = fsockopen($_SERVER["HTTP_HOST"], 80, $errno, $errstr, 30);

	 if (!$fp) {
   	 echo "$errstr ($errno)<br>";
	 }else{
     $url = substr($_SERVER["SCRIPT_NAME"],0,strpos($_SERVER["SCRIPT_NAME"],"JOWAMP_files"))."JOWAMP_files/execInBackground.php?exe=$exe&args=$args";
     
     $out = "GET $url HTTP/1.1\r\n";
     $out .= "Host: ".$_SERVER["HTTP_HOST"]."\r\n";
     $out .= "Connection: Close\r\n\r\n";

     fwrite($fp, $out);

     fclose($fp);
   }	 
	} 
}
	 
/**
 * Function used to get the system time. If the address of a NTP server is defined on JOWAMP_Constants file, this address
 * will be used to get the time reference. If not defined the system time will be used to get the time reference. 
 * It works in Windows and Linux platforms.
 */
function getTime() {
  // Include the constant definition file where all constants are definied.
	include("./JOWAMP_Constants.php");
	
	if(strlen($NTPserverAddress) == 0)
	  return time();
	else{	
  	$exe = "java -classpath ./owamp_protocol HiResTimer";
	  $args = "-n $NTPserverAddress -u $updateInterval";
		$time = exec($exe." ".$args,&$output,&$return_var);
		
	  if($return_var != 0){
		  $_SESSION['Error'] = "The NTP server $NTPserverAddress is not accessible or a receive time out occurred.";
	    echo '<meta HTTP-EQUIV="REFRESH" content="0; url=JOWAMP_Error.php">';	
			die();
		}		
		
		return $time/1000;
	}
	
}
 
/**
 * This function is used to verify if there is connection to the machine with IP $IP and if the OWAMP element in
 * port $port exits. To do so a connection setup is processed and ended with a ConnectionSetupClientResponse 
 * packet, with mode = 0 (means that the client will not continue with the session).
 */	 
function ConnectionSetup($IP,$port){

	// Open the connection to terminal
		
	if(substr_count($IP, "[")) // IPv6
  	if(substr_count($IP, "]:"))
  	  $fp = fsockopen(substr($IP,0,strpos($IP, "]:")+1),$port, $err_num, $err_msg, 30);
		else	
		  $fp = fsockopen($IP,$port, $err_num, $err_msg, 30);
	else // IPv4
	  if(substr_count($IP, ":"))
  	  $fp = fsockopen(substr($IP,0,strpos($IP, ":")),$port, $err_num, $err_msg, 30);
		else	
		  $fp = fsockopen($IP,$port, $err_num, $err_msg, 30);
 
  if ($fp){
	  // Send the ConnectionSetupClientResponse packet, with mode = 0 (means that the client will not continue with the session).
		$out = "";
		for($i = 0;$i<68;$i++)
		 $out = $out."0";

		fputs($fp, $out);
	  fflush($fp);
	  while (!feof($fp))    // Waits until the socket is closed (after receiving a ConnectionSetupClientResponse with
  	  fgets($fp, 1024);   // mode = 0 the element closes the sockect connection).
 
    fclose($fp);
    return true; 
  }else{
    return false;
  }
}


/**
* This function is used to verify if the sender address is a valid IP address. 
  The sender address should be in the following format:
      
     IPv4_address:TCPportNumber    // for IPv4 address
     [IPv6_address]:TCPportNumber  // for IPv6 address
       
  The TCPportNumber is the TCP port to be used in OWAMP-Control communication between the  
  Control-Client and the respective OWAMP-Sender. If the user wants to use the default TCPportNumber  
  the sender address can be in the following format: 
       
     IPv4_address    // for IPv4 address
     [IPv6_address]  // for IPv6 address
  In the variable senderAddress is returned the IP sender address ($senderAddress should be the pointer	to 
	senderAddress variable).
	If the senderTCPport exits it will be saved in the senderTCPport variable ($senderTCPport should be the pointer
	to senderTCPport variable).
	If an error ocurres the correspondent string error will be saved in the $error variable ($error should be the pointer
	to error variable).       
*/	 
function verifySenderAddress($senderAddress,$senderTCPport,$error){
  $senderAddressAux = $senderAddress;	
  if(substr_count($senderAddressAux,"[")==1){  // IPv6 address
    if(substr_count($senderAddressAux,"]:")){  // TCPportNumber to use in OWAMP-Control with sender specified.
      $senderTCPport = substr($senderAddressAux,strpos($senderAddressAux, "]:")+2);
			$senderAddress = substr($senderAddressAux,0,strpos($senderAddressAux, "]:")+1);
    }
		if(substr_count($senderAddressAux,"]")!=1){  // Invalid sender address.
      $error = ("The Sender address <strong>".$senderAddressAux."</strong> is not a valid IP address.");
    }
  }else{  // IPv4 address
    if(substr_count($senderAddressAux,":")){  // TCPportNumber to use in OWAMP-Control with sender specified.
      $senderTCPport = substr($senderAddressAux,strpos($senderAddressAux, ":")+1);
	    $senderAddress = substr($senderAddressAux,0,strpos($senderAddressAux, ":"));
    }
			 
	  if(substr_count($senderAddressAux,":")>1){  // Invalid sender address.
      $error = ("The Sender address <strong>".$senderAddressAux."</strong> is not a valid IPv4 address. IPv6 address should be entered between [].");
    }
			 			 
		if(substr_count($senderAddressAux,"]")){  // Invalid sender address.
      $error = ("The Sender address <strong>".$senderAddressAux."</strong> is not a valid IP address.");
    }
  }
   
  if ((!isset($error))&&($senderTCPport < 0 || $senderTCPport >= 65536)) {
	  $error = ("Sender TCP port number out of range (<strong>$senderTCPport</strong>).");
  }
		 
	if((!isset($error))&&(strlen($senderTCPport)==0)){
	  $error = ("The Sender address <strong>".$senderAddressAux."</strong> is not a valid IP address.");
	}
}	

/**
* This function is used to verify if the receiver address is a valid IP address. 
  The receiver address should be in the following format:
      
     IPv4_address     // for IPv4 address
     [IPv6_address]   // for IPv6 address
       
  The TCP port to be used in OWAMP-Control communication between the Server and receiver should be defined
  when running OWAMP_Server, or the default TCP port will be used.
	If an error ocurres the correspondent string error will be saved in the $error variable ($error should be the pointer
	to error variable).       
*/	 
function verifyReceiverAddress($receiverAddress,$error){
	
  if(substr_count($receiverAddress,"[")==1){  // IPv6 address
    if(substr_count($receiverAddress,"]:")){  // TCPportNumber to use in OWAMP-Control with receiver specified.
      $error = "A invalid Receiver address was introduced (<strong>".$receiverAddress."</strong>). ".
			         "The TCP port to be used in OWAMP-Control communication between the Server and receiver should be defined when running OWAMP_Server."; 		  
    }
		if(substr_count($receiverAddress,"]")!=1){  // Invalid receiver address.
      $error = ("The Receiver address <strong>".$receiverAddress."</strong> is not a valid IP address.");
    }
  }else{  // IPv4 address
    if(substr_count($receiverAddress,":")==1){  // TCPportNumber to use in OWAMP-Control with receiver specified.
			  $error = ("A invalid Receiver address was introduced (<strong>".$receiverAddress."</strong>). ".
			            "The TCP port to be used in OWAMP-Control communication between the Server and receiver should be defined when running OWAMP_Server."); 		  
    }
			 
		if(substr_count($receiverAddress,":")>1){  // Invalid receiver address.
      $error = ("The Receiver address <strong>".$receiverAddress."</strong> is not a valid IPv4 address. IPv6 address should be entered between [].");
    }
			 			 
		if(substr_count($receiverAddress,"]")){  // Invalid receiver address.
      $error = ("The Receiver address <strong>".$receiverAddress."</strong> is not a valid IP address.");
    }
  }
	
}
?>
